## mingw-w64-efxc2-0.0.14.278-1.src.tar.zst

=== CMakeLists.txt ===
#--------------------------------------------------------------------------------------
# File: CMakeLists.txt
#
# Copyright (c) J. Peter Mugaas
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.
#--------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.21)

set(EFXC2_VERSION 0.0.14.278)
project (efxc2 VERSION ${EFXC2_VERSION}
  DESCRIPTION "Enhanced fxc2"
  HOMEPAGE_URL "https://github.com/JPeterMugaas/efxc2"
  LANGUAGES CXX)

include(GNUInstallDirs)

set(PROJECT_COMPANY "J. Peter Mugaas")
set(PROJECT_COPYRIGHT "Copyright (c) 2024 ${PROJECT_COMPANY}")

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(EFXC2_FMT_PATH "{fmt} path" "")
option(EFXC2_BUILD_STATIC "Build with static libraries." ON)
option(EFXC2_USE_PVS_STUDIO "Enable analysis with PVS-Studio" OFF)
option(EFXC2_USE_ALL_RULES "Use all rules with PVS-Editor" OFF)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${EFXC2_FMT_PATH}/lib/cmake")
list(APPEND CMAKE_INCLUDE_PATH "${EFXC2_FMT_PATH}/include")
list(APPEND CMAKE_LIBRARY_PATH "${EFXC2_FMT_PATH}/lib")

message(STATUS "Check for C++20 std::bit_cast support")
file(WRITE
  ${CMAKE_BINARY_DIR}/CMakeTmp/testCCompiler.cpp
  "#include <iostream>\r\n"
  "#include <string>\r\n"
  "#include <bit>\r\n"
    "\r\n"
    "int main()\r\n"
    "{\r\n"
    "int number = -1;\r\n"
    "std::cout << std::to_string(std::bit_cast<unsigned int>(number));\r\n"
    "return 0;\r\n"
    "}\r\n")
try_compile(BIT_CAST_SUPPORTED
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/CMakeTmp/testCCompiler.cpp
  OUTPUT_VARIABLE OUTPUT)
if (BIT_CAST_SUPPORTED)
    message(STATUS "Check for C++20 std::bit_cast support - yes")
else()
    message(STATUS "Check for C++20 std::bit_cast support - no")
endif()


message(STATUS "Check for C++20 std::ranges support")
file(WRITE
  ${CMAKE_BINARY_DIR}/CMakeTmp/testCCompiler.cpp
  "#include <algorithm>\r\n"
  "#include <iostream>\r\n"
  "#include <ranges>\r\n"
  "#include <vector>\r\n"
  "\r\n"
  "int main()\r\n"
  "{\r\n"
  "std::vector<int> numbers = { 1, 2, 3, 4, 5, 6 };\r\n"
  "\r\n"
  "auto print = [](const int& n) { std::cout << n << ' '; };\r\n"
  "\r\n"
  "std::ranges::for_each (numbers.begin(), numbers.end(), print);\r\n"
  "return 0;\r\n"
  "}\r\n")
try_compile(RANGES_SUPPORTED
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/CMakeTmp/testCCompiler.cpp
  OUTPUT_VARIABLE OUTPUT)
if (RANGES_SUPPORTED)
    message(STATUS "Check for C++20 std::ranges support - yes")
else()
    message(STATUS "Check for C++20 std::ranges support - no")
endif()

set(USE_FMT_LIBRARY OFF)
message(STATUS "Check for C++20 formatting library")
file(WRITE
  ${CMAKE_BINARY_DIR}/CMakeTmp/testCCompiler.cpp
  "#include <iostream>\r\n"
  "#include <format>\r\n"
  "\r\n"
  "int main()\r\n"
  "{\r\n"
  "    std::cout << std::format(\"Hello {}\", \"world\");\r\n"
  "    return 0;\r\n"
  "}\r\n")
try_compile(FORMAT_SUPPORTED
  ${CMAKE_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/CMakeTmp/testCCompiler.cpp
  OUTPUT_VARIABLE OUTPUT)
if (FORMAT_SUPPORTED)
    message(STATUS "Check for C++20 formatting library  - no external library required.")
else()
    if (MSVC)
       message(STATUS "downloading \{fmt\}")
       include(FetchContent)

       FetchContent_Declare(
          fmt
          GIT_REPOSITORY https://github.com/fmtlib/fmt
          GIT_TAG        e69e5f977d458f2650bb346dadf2ad30c5320281) # 10.2.1
       FetchContent_MakeAvailable(fmt)
       set(USE_FMT_LIBRARY ON)
       set(FORMAT_SUPPORTED ON)
    else()
       find_package(fmt QUIET)
       if (fmt_FOUND)
         set(FORMAT_SUPPORTED ON)
       endif()
    endif()
    if (FORMAT_SUPPORTED)
       message(STATUS "Check for C++20 formatting library  - \{fmt\} library")
       set(USE_FMT_LIBRARY ON)
    else()
       message(STATUS "Check for C++20 formatting library  - not found")
       message(FATAL_ERROR "\{fmt\} library required.")
    endif()
endif()

set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

set(EXEC_SOURCES efxc2.cpp
                 efxc2Cmds.h
                 efxc2Cmds.cpp
                 efxc2Compiler.h
                 efxc2Compiler.cpp
                 efxc2CompilerAPIContainer.h
                 efxc2CompilerAPIContainer.cpp
                 efxc2CompilerIncludes.h
                 efxc2CompilerIncludes.cpp
                 efxc2Console.h
                 efxc2CompilerParams.h
                 efxc2CompilerParams.cpp
                 efxc2CompilerTasks.h
                 efxc2CompilerTasks.cpp
                 efxc2Exception.h
                 efxc2Files.h
                 efxc2Files.cpp
                 efxc2Utils.h
                 efxc2Utils.cpp
                 efxc2.h)

#----resources for .exe

string(REPLACE "." "," _RC_VER ${PROJECT_VERSION})

file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/efxc2.ico" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/settings.manifest" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/build/efxc2.rc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/efxc2.rc" @ONLY)

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/build/config.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/config.h" @ONLY)
list(APPEND EXEC_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/config.h")
    
list(APPEND EXEC_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/efxc2.rc")
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(fxc ${EXEC_SOURCES})
set_target_properties(fxc PROPERTIES RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_CURRENT_BINARY_DIR})
target_compile_definitions(fxc PRIVATE _UNICODE UNICODE)

if (USE_FMT_LIBRARY)
target_link_libraries(fxc fmt::fmt)
endif()

if(EFXC2_BUILD_STATIC)
  IF (WIN32)
    target_link_options(fxc PRIVATE $<$<CXX_COMPILER_ID:Clang,IntelLLVM,GNU>:-municode  -static>)
  else()
    target_link_options(fxc PRIVATE $<$<CXX_COMPILER_ID:Clang,IntelLLVM,GNU>:-static>)
  endif()
else()
  if (WIN32)
    target_link_options(fxc PRIVATE $<$<CXX_COMPILER_ID:Clang,IntelLLVM,GNU>:-municode>)
  endif()
endif()

install(TARGETS fxc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if(_MSC_VER)
  target_compile_options(fxc PUBLIC "/ZI")
  target_link_options(fxc PUBLIC "/INCREMENTAL")
endif()

install(FILES 
  ${CMAKE_CURRENT_SOURCE_DIR}/README.md
  ${CMAKE_CURRENT_SOURCE_DIR}/license_MPL_2_0.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/HISTORY.md
  ${CMAKE_CURRENT_SOURCE_DIR}/INSTALL.md
  DESTINATION ${CMAKE_INSTALL_DOCDIR})

if(EFXC2_USE_PVS_STUDIO)
  include(${CMAKE_SOURCE_DIR}/build/PVS-Studio.cmake) 
  if (EFXC2_USE_ALL_RULES)
     pvs_studio_add_target(TARGET fxc.analyze ALL
                      OUTPUT FORMAT sarif
                      ANALYZE fxc
                      MODE 64;GA:1,2;CS;OWASP;AUTOSAR;MISRA 
                      LOG pvs-studio.sarif)
  else()
    pvs_studio_add_target(TARGET fxc.analyze ALL
                      OUTPUT FORMAT sarif      
                      ANALYZE fxc
                      MODE 64;GA:1,2;CS
                      LOG pvs-studio.sarif)
  endif()
endif()

set(CPACK_GENERATOR ZIP)

include(CPack)
enable_testing()

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests/Compiled)
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/tests/BC7Encode.hlsl DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/tests)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/tests/Empty_file.hlsl "")

add_test(NAME help
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests
  COMMAND fxc --help)
add_test(NAME nologo 
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests
  COMMAND fxc /nologo BC7Encode.hlsl /WX /Ges /Zi /Zpc /Qstrip_reflect /Qstrip_debug /Tcs_5_0 /ETryMode456CS /FhCompiled/BC7Encode_TryMode456CS.inc  /VnBC7Encode_TryMode456CS)
add_test(NAME default_PDB_filename
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests
  COMMAND fxc BC7Encode.hlsl /debug /WX /Ges /Zi /Zpc /Zss /Qstrip_reflect /Qstrip_debug /Tcs_5_0 /ETryMode456CS /FhCompiled/BC7Encode_TryMode456CS.inc /FdCompiled/ /VnBC7Encode_TryMode456CS)
add_test(NAME default_PDB_filename_dot
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests
  COMMAND fxc BC7Encode.hlsl /debug /WX /Ges /Zi /Zpc /Zss /Qstrip_reflect /Qstrip_debug /Tcs_5_0 /ETryMode456CS /FhCompiled/BC7Encode_TryMode456CS.inc /FdCompiled/. /VnBC7Encode_TryMode456CS)
add_test(NAME short_cmd.BC7Encode_TryMode456CS
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests
  COMMAND fxc BC7Encode.hlsl /debug /WX /Ges /Zi /Zpc /Qstrip_reflect /Qstrip_debug /Tcs_5_0 /ETryMode456CS /FhCompiled/BC7Encode_TryMode456CS.inc  /VnBC7Encode_TryMode456CS)
add_test(NAME short_cmd.BC7Encode_TryMode456CS_cs40
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests 
  COMMAND fxc BC7Encode.hlsl /debug /WX /Ges /Zi /Zpc /Qstrip_reflect /Qstrip_debug /Tcs_4_0 /ETryMode456CS /FhCompiled/BC7Encode_TryMode456CS_cs40.inc  /VnBC7Encode_TryMode456CS) 
add_test(NAME long_cmd.BC7Encode_TryMode456CS
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests
  COMMAND fxc ${CMAKE_CURRENT_SOURCE_DIR}/tests/BC7Encode.hlsl /debug /WX /Ges /Zi /Zpc /Qstrip_reflect /Qstrip_debug /Tcs_5_0 /ETryMode456CS /Fh${CMAKE_CURRENT_BINARY_DIR}/tests/Compiled/BC7Encode_TryMode456CS.inc /Fd${CMAKE_CURRENT_BINARY_DIR}/tests/Compiled/BC7Encode_TryMode456CS.pdb /VnBC7Encode_TryMode456CS)
add_test(NAME long_cmd.BC7Encode_TryMode456CS_cs40
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests
  COMMAND fxc ${CMAKE_CURRENT_SOURCE_DIR}/tests/BC7Encode.hlsl /debug /WX /Ges /Zi /Zpc /Qstrip_reflect /Qstrip_debug /Tcs_4_0 /ETryMode456CS /Fh${CMAKE_CURRENT_BINARY_DIR}/tests/Compiled/BC7Encode_TryMode456CS_cs40.inc /Fd${CMAKE_CURRENT_BINARY_DIR}/tests/Compiled/BC7Encode_TryMode456CS.pdb /VnBC7Encode_TryMode456CS)
add_test(NAME short_cmd.BC7Encode_no_vn
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests
  COMMAND fxc BC7Encode.hlsl /debug /WX /Ges /Zi /Zpc /Qstrip_reflect /Qstrip_debug /Tcs_5_0 /ETryMode456CS /FhCompiled/BC7Encode_no_vn.inc)
add_test(NAME hex_BC7Encode_no_vn
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests
  COMMAND fxc BC7Encode.hlsl /debug /WX /Ges /Zi /Zpc /Qstrip_reflect /Qstrip_debug /Tcs_5_0 /ETryMode456CS /Lx /FhCompiled/BC7Encode_hex.inc)
add_test(NAME error.input_file_not_found
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests
  COMMAND fxc NotFound.hlsl /debug /WX /Ges /Zi /Zpc /Qstrip_reflect /Qstrip_debug /Tcs_5_0 /ETryMode456CS /Lx /FhCompiled/BC7Encode_hex.inc)
set_tests_properties(error.input_file_not_found PROPERTIES WILL_FAIL true)
add_test(NAME error.output_file_not_found
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests
  COMMAND fxc ${CMAKE_CURRENT_SOURCE_DIR}/tests/BC7Encode.hlsl /WX /Ges /Zi /Zpc /Qstrip_reflect /Qstrip_debug /Tcs_4_0 /ETryMode456CS /Fh${CMAKE_CURRENT_BINARY_DIR}/not_found/Compiled/BC7Encode_TryMode456CS_cs40.inc /Fd${CMAKE_CURRENT_BINARY_DIR}/Compiled/BC7Encode_TryMode456CS.pdb /VnBC7Encode_TryMode456CS)
set_tests_properties(error.output_file_not_found PROPERTIES WILL_FAIL true)
add_test(NAME error.output_file_empty
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tests
  COMMAND fxc ${CMAKE_CURRENT_BINARY_DIR}/tests/Empty_file.hlsl /debug /WX /Ges /Zi /Zpc /Qstrip_reflect /Qstrip_debug /Tcs_4_0 /ETryMode456CS /Fh${CMAKE_CURRENT_BINARY_DIR}/not_found/Compiled/BC7Encode_TryMode456CS_cs40.inc /Fd${CMAKE_CURRENT_BINARY_DIR}/Compiled/BC7Encode_TryMode456CS.pdb /VnBC7Encode_TryMode456CS)
set_tests_properties(error.output_file_empty PROPERTIES WILL_FAIL true)
add_test(NAME error.preprocess_with_fo
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests//leason/test_2
  COMMAND fxc BloomCombine.hlsl /debug /I include /P ${CMAKE_CURRENT_BINARY_DIR}/tests/BloomCombin_ps_2..hlsl /E main /T ps_4_0_level_9_1 /Zi /Fo${CMAKE_CURRENT_BINARY_DIR}/tests/BloomCombin_ps_2..cso)
set_tests_properties(error.preprocess_with_fo PROPERTIES WILL_FAIL true)

=== PKGBUILD ===
# Maintainer: J. Peter Mugaas <jpmugaas@suddenlink.net>

_realname=efxc2
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.0.14.278
pkgrel=1
pkgdesc="Enhanced version of fxc2 (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/JPeterMugaas/efxc2"
license=('spdx:MPL-2.0')
makedepends=("${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cc")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
source=("${_realname}-${pkgver}.tar.gz"::"https://github.com/JPeterMugaas/efxc2/archive/refs/tags/${pkgver}.tar.gz")
sha256sums=('a6685e206d1fef5f13c134a77ffcb1bab622d03d33fb2c1b68b8b38b73b69267')

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DEFXC2_BUILD_STATIC=OFF \
      "${extra_config[@]}" \
      ../${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build . --target test
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/license_MPL_2_0.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}

=== build/PKGBUILD ===
#--------------------------------------------------------------------
# File: PKGBUILD
#
# Copyright (c) J. Peter Mugaas
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.
#--------------------------------------------------------------------

# Important!!!
#
# This is NOT meant for general usage or deployment.  It should
# never be in the MSYS2 archives.  It's for internal use.
#
# It's purpose is to:
# 1) Test compile the program for mingw64, clang64, and ucrt64
#    using the MSYS2 makepkg-mingw command.
# 2) Run the CMake tests.
# 3) Create a general purpose Windows distribution of this program.
#    This is a .ZIP containing a statically linked version of the
#    program along with the associated documentation.
#
# If you do not have PVS-Studio (https://www.pvs-studio.com/), disable it by setting "EFXC2_USE_PVS_STUDIO" to "OFF".
_realname=efxc2
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
provides=("${MINGW_PACKAGE_PREFIX}-${_realname}-git")
conflicts=("${MINGW_PACKAGE_PREFIX}-${_realname}-git"
           "${MINGW_PACKAGE_PREFIX}-fxc2")
replaces=("${MINGW_PACKAGE_PREFIX}-${_realname}-git")
pkgver=0.0.13.271
pkgrel=1
pkgdesc="Enhanced version of fxc2 (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32' 'clangarm64')
url='https://github.com/mozilla/fxc2/'
license=('spdx:MPL-2.0')
options=('strip' 'staticlibs')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "zip")

pkgver() {
  cd "${srcdir}"
  grep -m 1 "EFXC2_VERSION" ../../CMakeLists.txt | sed 's/[^0-9.]*//g' | cut -c2-
}

prepare() {
  mkdir -p "${srcdir}"/${_realname}
  cd "${srcdir}"/${_realname}
  cp ../../../*.cpp .
  cp ../../../*.h .
  cp ../../../CMakeLists.txt .
  cp ../../../*.md .
  cp ../../../*.txt .
  cp ../../../*.ico .
  cp ../../../*.manifest .
  mkdir -p build
  cd build
  cp ../../../../build/*.in .
  cp ../../../../build/*.cmake .
  cd ..
  mkdir -p tests
  cd tests
  cp -r ../../../../tests/* .
}

build() {
  cd "${srcdir}/${_realname}"
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DEFXC2_USE_PVS_STUDIO=ON \
      -DEFXC2_USE_ALL_RULES=ON \
      "${extra_config[@]}" \
      ../${_realname}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  DIRECTXMESH_MEDIA_PATH=/home/jpmugaas/git/directxmeshmedia \
    "${MINGW_PREFIX}"/bin/cmake.exe --build . --target test || true
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .
  mkdir -p zip
  cd zip
  cp "${pkgdir}/${MINGW_PREFIX}"/bin/*.exe .
  cp "${pkgdir}/${MINGW_PREFIX}/share/doc/${_realname}"/*.md .
  cp "${pkgdir}/${MINGW_PREFIX}/share/doc/${_realname}"/*.txt .
  case ${CARCH} in
     "i686")
	    _OS="win32"
	 ;;
	 "aarch64")
	    _OS="win64"
	 ;;
	 "x86_64")
        _OS="win64"
	 ;;
	 *) 
  esac	 
  zip -t $(date '+%m%d%Y') "${_realname}-${CARCH}-${_OS}-${pkgver}.zip" *.exe *.txt *.md
  cp *.zip ../../../
  cd ..
  if [ -f pvs-studio.sarif ]; then
    cp pvs-studio.sarif ../../pvs-studio-${MSYSTEM}.sarif
  fi
 }

=== build/msys/PKGBUILD ===
#--------------------------------------------------------------------
# File: PKGBUILD
#
# Copyright (c) J. Peter Mugaas
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.
#--------------------------------------------------------------------
#
# This is NOT meant for general usage or deployment.  It should
# never be in the MSYS2 archives.  It's for internal use.
#
# Its purpose is to test compile efxc2 for the MSYS platform.
_realname=efxc2
pkgbase=${_realname}
pkgname=("${_realname}")
pkgver=0.0.10.225
pkgrel=1
pkgdesc="Enhanced version of fxc2 (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32' 'clangarm64')
url='https://github.com/mozilla/fxc2/'
license=('spdx:MPL-2.0')
options=('strip' 'staticlibs')
makedepends=("cmake")

pkgver() {
  cd "${srcdir}/${_realname}"
  grep -m 1 "EFXC2_VERSION" CMakeLists.txt | sed 's/[^0-9.]*//g' | cut -c2-
}

prepare() {
  mkdir -p "${srcdir}"/${_realname}
  cd "${srcdir}"/${_realname}
  cp ../../../../*.cpp .
  cp ../../../../*.h .
  cp ../../../../CMakeLists.txt .
  cp ../../../../*.md .
  cp ../../../../*.txt .
  cp ../../../../*.ico .
  cp ../../../../*.manifest .
  mkdir -p build
  cd build
  cp ../../../../../build/*.in .
  cp ../../../../../build/*.cmake .
  cd ..
  mkdir -p tests
  cd tests
  cp -r ../../../../../tests/* .
}

build() {
  cd "${srcdir}/${_realname}"
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  set PATH %PATH%:"/c/Program\ Files\ \(x86\)/PVS-Studio/" 
  cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DEFXC2_BUILD_STATIC=OFF \
      -DEFXC2_USE_PVS_STUDIO=OFF \
      -DEFXC2_USE_ALL_RULES=ON \
      ${extra_config[@]} \
      ../${_realname}

  cmake.exe --build .
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  cmake.exe --build . --target test || true
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" cmake.exe --install .
}
